Package org.apache.sysds.hops

# Class DnnOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.MultiThreadedHop
org.apache.sysds.hops.DnnOp

All Implemented Interfaces:
  `ParseInfo`

public class DnnOp extends MultiThreadedHop

## Field Summary

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`DnnOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOpDnn o, ArrayList<Hop> inp)`
Create a hop from the builtin expression

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`Lop`
`constructDnnLops(Types.ExecType et, List<Hop> inputs)`
`Lop`
`constructLops()`
`Types.OpOpDnn`
`getOp()`
`String`
`getOpString()`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isMultiThreadedOpType()`
`boolean`
`isStride1Pad0()`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.
`void`
`setOp(Types.OpOpDnn op)`

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### DnnOp

public DnnOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOpDnn o, ArrayList<Hop> inp)
Create a hop from the builtin expression

Parameters:
  `l` - name of the hop
  `dt` - datatype (only supports matrix datatype)
  `vt` - valuetype (only supports matrix valuetype)
  `o` - type of this hop
  `inp` - input hops

## Method Details

### getOp

public Types.OpOpDnn getOp()

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### isMultiThreadedOpType

public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### setOp

public void setOp(Types.OpOpDnn op)

### isStride1Pad0

public boolean isStride1Pad0()

### constructDnnLops

public Lop constructDnnLops(Types.ExecType et, List<Hop> inputs)

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`